function KeyboardController(client){
	var self = this; self.name = "KeyboardController"; // MANDATORY

    this.keyboardShifted = false;
    this.client = client;
       
    $(window).keypress(function(event){
        self.wrapKeyPress(event.which,self.keyboardShifted);
    });  

    $(window).on("keyup",function(event) {
        if(event.which == 16) {
            self.keyboardShifted = false;
        }
        self.wrapKeyUp(event.which,self.keyboardShifted);
    });

    $(window).on("keydown",function(event) {
        if(event.which == 16) {
            self.keyboardShifted = true;
        }        
        self.wrapKeyDown(event.which,self.keyboardShifted);
    });
    
    this.wrapKeyUp = function(keyCode,shifted){      
        if(typeof(self.client) !== 'undefined'){
            if(typeof(self.client.keyUp) !== 'undefined'){
                self.client.keyUp(keyCode,shifted);
            }
        }
    };
    
    this.wrapKeyDown = function(keyCode,shifted){       
        if(typeof(self.client) !== 'undefined'){
            if(typeof(self.client.keyDown) !== 'undefined'){
                self.client.keyDown(keyCode,shifted);
            }
        }
    };
    
    this.wrapKeyPress = function(keyCode,shifted){       
        if(typeof(self.client) !== 'undefined'){
            if(typeof(self.client.keyPress) !== 'undefined'){
                self.client.keyPress(keyCode,shifted);
            }
        }
    };
    
}	
KeyboardController.prototype = new SystemController();
    
