var main_tizen = {
}
var player = null;
var transfer = false;
var manager = false;
var nodeJS_started = 0;

$(document).ready(function(){	
	
	var systemInfo = navigator.userAgent || navigator.vendor || window.opera;
	systemInfo = systemInfo.toLowerCase();
	var tizen_version = systemInfo.substring(systemInfo.lastIndexOf("tizen"),systemInfo.lastIndexOf("tizen")+11);
	tizen_version = parseInt(tizen_version.substring(tizen_version.length-5,tizen_version.length));
	if(tizen_version > 3){
		try{
			b2bapis.b2bcontrol.startNodeServer("../server.js", "SSSPServer", function(){
				$("#starter").html("[Initial Boot] success ");
				nodeJS_started = 1;
				startApp();
			},function(error){
				$("#starter").html("[Initial Boot] code :" + error.code + " error name: " + error.name + "  message " + error.message);
				nodeJS_started = -1;
				startApp();
			});
		}catch(e){
			$("#starter").html("[Initial Boot] Exception");
			nodeJS_started = -1;
			startApp();
		}
	}else if(tizen_version > 2){
		startApp();
	}else{
		startApp();
	}
});

function startApp(){
	$("#starter").html("NodeJS Status : "+nodeJS_started);
	document.addEventListener('keydown', self.onKeyDown, false);
	$.get('file:///opt/usr/media/Documents/app/tizen.html', function(data, status) {
		$("#starter").html("File request status: "+status);
	}).done(function() {
		$("#starter").html("System is updatable.");
		$.get('file:///opt/usr/media/Documents/url.ver', function(dataURL, status) {
			$.get('file:///opt/usr/apps/9A3yAedyAS/res/wgt/admira.ver', function(dataURLi, status) {
				dataURL = dataURL.replace(/[^a-zA-Z0-9]/g, '');
				dataURLi = dataURLi.replace(/[^a-zA-Z0-9]/g, '');
				if(dataURL != dataURLi){
					$("#starter").html("Different App version found, must update -- dataURL: "+dataURL+ " dataURLi:"+dataURLi);
					$(document).ready(function(){
						if(!player){
							player = new PlayerController();
							$(player).on("PlayerDataLoaded",onPlayerDataLoaded);
							player.init();
						}
					});
				}
				else{
					$("#starter").html("Same version, all good.");
					document.location ="file:///opt/usr/media/Documents/app/tizen.html";
				}
			}).fail(function() {
				$("#starter").html("Could not get : admira.ver");
				$(document).ready(function(){
					if(!player){
						player = new PlayerController();
						$(player).on("PlayerDataLoaded",onPlayerDataLoaded);
						player.init();
					}
				});
			});
		}).fail(function() {
			$("#starter").html("Could not get : url.ver");
			$(document).ready(function(){
				if(!player){
					player = new PlayerController();
					$(player).on("PlayerDataLoaded",onPlayerDataLoaded);
					player.init();
				}
			});
		});
	}).fail(function(e) {
		$.get('file:///opt/usr/home/owner/content/Documents/app/tizen.html', function(data, status) {
			$("#starter").html("File request status: "+status);
		}).done(function() {
			$("#starter").html("System is updatable.");
			$.get('file:///opt/usr/home/owner/content/Documents/url.ver', function(dataURL, status) {
				$.get('file:///opt/usr/home/owner/apps_rw/9A3yAedyAS/res/wgt/admira.ver', function(dataURLi, status) {
					dataURL = dataURL.replace(/[^a-zA-Z0-9]/g, '');
					dataURLi = dataURLi.replace(/[^a-zA-Z0-9]/g, '');
					if(dataURL != dataURLi){
						$("#starter").html("Different App version found, must update -- dataURL: "+dataURL+ " dataURLi:"+dataURLi);
						$(document).ready(function(){
							if(!player){
								player = new PlayerController();
								$(player).on("PlayerDataLoaded",onPlayerDataLoaded);
								player.init();
							}
						});
					}
					else{
						$("#starter").html("Same version, all good.");
						document.location ="file:///opt/usr/home/owner/content/Documents/app/tizen.html";
					}
				}).fail(function() {
					$("#starter").html("Could not get : admira.ver");
					$(document).ready(function(){
						if(!player){
							player = new PlayerController();
							$(player).on("PlayerDataLoaded",onPlayerDataLoaded);
							player.init();
						}
					});
				});
			}).fail(function() {
				$("#starter").html("Could not get : url.ver");
				$(document).ready(function(){
					if(!player){
						player = new PlayerController();
						$(player).on("PlayerDataLoaded",onPlayerDataLoaded);
						player.init();
					}
				});
			});
		}).fail(function(e) {
			$("#starter").html("Has no external installation");
			$(document).ready(function(){
				if(!player){
					player = new PlayerController();
					$(player).on("PlayerDataLoaded",onPlayerDataLoaded);
					player.init();
				}
			});
		});
	});
}

function onPlayerDataLoaded(){
	//$("#starter").hide();
	player.OS.updateURL(function(err_updateURL,result_updateURL){
	//	$("#starter").hide();
    if(!transfer){
        transfer = new TransferService();
        transfer.setTimeCallback = player.setUseServerTime;
        transfer.init(player.version,player.platform);
    }
    transfer.update(player.timestamp,player.dataManager.getArchiveFiles());
    transfer.activateLogger(player.debug);
    if(!manager){
        manager = new ManagerService();
        manager.init();
    }
    var scheduleConfig = player.config.getScheduleConfig();
    manager.update(scheduleConfig);
    manager.activateLogger(player.debug);
    setTimeout(function(){
    	if(!timerService){
    		timerService = new TimerService();
    	}
    	timerService.checkTimers(scheduleConfig);
    }, 15000);
	});
}
this.onKeyDown = function (event) {
	"use strict";
	var keyCode = event.keyCode;

	switch (keyCode) {
	    case 38:    // MediaPause
	    	player.debug = !player.debug;
            player.setLogger($("#playerLog"));
            manager.setLogger($("#transferLog"));
            transfer.setLogger($("#transferLog"));
            player.activateLogger(player.debug);
            transfer.activateLogger(player.debug);
	    break;
		default:
			player.log(keyCode);
		break;
	}
};
