var player = false;
var transfer = false;
var inactivityTimer = 0;
var manager = false;

document.addEventListener('deviceready', function(){
    window.plugins.insomnia.keepAwake();
    var appDir = "";
    var systemInfo = navigator.userAgent || navigator.vendor || window.opera;
    systemInfo = systemInfo.toLowerCase();
    var uuid = device.uuid;
    console.log("UUID is : "+uuid);
    if(systemInfo.match(/iphone/i)
          || systemInfo.match(/ipad/i)
          || systemInfo.match(/ipod/i)){
            appDir = cordova.file.documentsDirectory+"ADmira/";
    }else if(systemInfo.match(/android/i)){
        appDir = cordova.file.externalRootDirectory+"ADmira/";
    }
    $.get(appDir+'app/cordova.ver', function(data, status) {  
       console.log("File request status: "+status); 
    }).done(function() {
        console.log("System is updatable.");
        document.location = appDir+"app/cordova.html";
        console.log( "second success" );
    }).fail(function() {
        console.log("has no external installation");
        $(document).ready(function(){  
            if(!player){
                player = new PlayerController();
                $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
                player.init();
            }        
        });
    });
}, false);  

function onPlayerDataLoaded(){  
    if(player.platform == "ANDROID"){
        cordova.plugins.backgroundMode.enable();
    }
    if(!transfer){
        transfer = new TransferService();
        transfer.init(player.version);
        transfer.setLogger(player.logger);
    }
    transfer.update(player.timestamp,player.dataManager.getArchiveFiles());
    transfer.activateLogger(player.debug);
    if(!manager){
        manager = new ManagerService();
        manager.init();
        manager.setLogger(player.logger);
    }
    manager.update(player.config.getScheduleConfig());
    manager.activateLogger(player.debug);
    
    //Kiosk.setKioskEnabled(player.config.getAlwaysOnTop());
}
