var main_tizen = {
}
var player = null;
var transfer = false;
var manager = false;
var timerService = null;
$(document).ready(function(){
	document.addEventListener('keydown', self.onKeyDown, false);
    player = new PlayerController();
    $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
    player.init();
});


function onPlayerDataLoaded(){
	$("#starter").hide();
    if(!transfer){
        transfer = new TransferService();
        transfer.setTimeCallback = player.setUseServerTime;
        transfer.init(player.version,player.platform);
    }
    transfer.update(player.timestamp,player.dataManager.getArchiveFiles());
    transfer.activateLogger(player.debug);
    if(!manager){
        manager = new ManagerService();
        manager.init();
    }
    var scheduleConfig = player.config.getScheduleConfig();
    manager.update(scheduleConfig);
    manager.activateLogger(player.debug);
    setTimeout(function(){
    	if(!timerService){
    		timerService = new TimerService();
    	}
    	timerService.checkTimers(scheduleConfig);
    }, 15000);
		setTimeout(function(){transfer.OS.insertTimersOrReboot(player.config.getForceReboot24h());}, 30000);
}


this.onKeyDown = function (event) {
	"use strict";
	var keyCode = event.keyCode;

	switch (keyCode) {
	    case 38:    // MediaPause
	    	player.debug = !player.debug;
            player.setLogger($("#playerLog"));
            manager.setLogger($("#transferLog"));
            transfer.setLogger($("#transferLog"));
            player.activateLogger(player.debug);
            transfer.activateLogger(player.debug);
	    break;
		default:
			player.log(keyCode);
		break;
	}
};
